--[[
	Zone Functions
	v1.6.7a
]]

-- Return the Special Zone mount mode. This is used for areas that don't allow flying in certain spots like Dalaran & Wintergrasp.
function MiniMount_ZoneSmart(cmt)
	local mode,_ = MiniMount_ZoneGetData(cmt);

	return mode;
end

-- Determine if a new mount must be called.
function MiniMount_ZoneSmartNewMount(cmt)
	local _, newmount = MiniMount_ZoneGetData(cmt);

	if newmount == true then
		MiniMount_GetNextMount();
	end
end


-- Main Zone Data Function
function MiniMount_ZoneGetData(CurrentMountType)
	SetMapToCurrentZone();
	MiniMount_DetermineNorthrendFly();
	local zone, subzone = GetZoneText(), GetSubZoneText();
	local continent = GetCurrentMapContinent();
	local newmount = nil;
	local mode = "Ground";

	if (continent == 3) and (MiniMount_RidingSkill >= 225) then
		mode = "Fly";
	elseif (continent == 4) and (MiniMount_CanNorthrendFly == true) then
		mode = "Fly"
	end

	if (zone == MINIMOUNT_ZONE_DALARAN) then
		if (MiniMount_CanNorthrendFly == true) then
			if subzone == MINIMOUNT_SUBZONE_DALARAN_KRASUSLANDING or subzone == MINIMOUNT_SUBZONE_DALARAN_THEVIOLETCITADEL then
				mode = "Fly";
			else
				mode = "Ground";
			end
		else
			mode = "Ground";
		end
	elseif (zone == MINIMOUNT_INSTANCE_THEOCULUS) then
		mode = "Ground";
	elseif (zone == MINIMOUNT_RAID_THEOBSIDIANSANCTUM) then
		mode = "Ground";
	elseif (zone == MINIMOUNT_RAID_THEEYEOFETERNITY) then
		mode = "Ground";
	end

	if (mode ~= nil) and (mode ~= CurrentMountType) then
		newmount = true;
	end

	return mode, newmount;
end